#define SEG_NUM 8
#define DNUM    4
#define CW_NUM  2


enum SPL {c_anode, c_cathode}ssg_pl;
u8 dbuf[DNUM];
bool dpp[DNUM];

struct GDF
{
 GPIO_TypeDef *GPIOx;
 GPIO_Pin_TypeDef GPIO_Pin;
};

struct CW_GDF
{
 GDF wire[CW_NUM];
};

GDF seg_wire[SEG_NUM]=
{
 //seg A
 {
  GPIOD,
  GPIO_PIN_7
 },
 //seg B
 {
  GPIOD,
  GPIO_PIN_6
 },
 //seg C
 {
  GPIOD,
  GPIO_PIN_5
 },
 //seg D
 {
  GPIOD,
  GPIO_PIN_4
 },
 //seg E
 {
  GPIOD,
  GPIO_PIN_3
 },
 //seg F
 {
  GPIOD,
  GPIO_PIN_2
 },
 //seg G
 {
#ifdef debug
  GPIOE,
  GPIO_PIN_0
#else
  GPIOD,
  GPIO_PIN_1
#endif
 },
 //seg H
 {
  GPIOD,
  GPIO_PIN_0
 }
};

CW_GDF com_wire[DNUM]=
{
 //dgt 0
 {
  GPIOA,
  GPIO_PIN_3,
  GPIOF,
  GPIO_PIN_4,
 },
 //dgt 1
 {
  GPIOC,
  GPIO_PIN_7,
  GPIOE,
  GPIO_PIN_5,
 },
 //dgt 2
 {
  GPIOC,
  GPIO_PIN_3,
  GPIOC,
  GPIO_PIN_6,
 },
 //dgt 3
 {
  GPIOC,
  GPIO_PIN_4,
  GPIOC,
  GPIO_PIN_5,
 }
};


void init_dpins(GDF*, CW_GDF*);