#include <kb.h>

void init_btn_pin (GDF *pin)
{
 u8 kl = (u8)pin->GPIO_Pin;

 pin->GPIOx->DDR &= ~kl;
 pin->GPIOx->CR1 |= kl;
}

// key_st[]   , ount[][3]   ,
//keyst btn[]   , pos   
void read_key(bool key_st[], u8 count[][3], keyst btn[], u8 pos=0)
{
 //   
 if (!(*key_st)) //     
 {
  if(count[pos][0]>lp)
  {
   count[pos][0]=0;

   if(btn[pos]==rls) btn[pos]=prs;

   if(count[pos][1]>lh)
   {
    btn[pos]=hold;
    count[pos][1]=0;
   }
   else
    count[pos][1]++;
  }
  else
   count[pos][0]++;

  count[pos][2]=lr;
 }
 else //   ,       
 {
  if(count[pos][2])
   count[pos][2]--;
  else
  {
   count[pos][0]=0;
   count[pos][1]=0;

   btn[pos]=rls;
  }
 }
}

void read_btn(GDF *pin)
{
 static bool i_trg=0;
 if(!i_trg)
 {
  i_trg=1;
  init_btn_pin(&GPIO_btn);
 }

 static u8 count[1][3];

 bool tmp = !!(pin->GPIOx->IDR & (u8)pin->GPIO_Pin);

 read_key(&tmp, count, &btn);
}