
__no_init
struct
{
 u8 init;

} eep @ 0x4000;

class //periph_init
{
 public:
 void gpio()  //GPIO_ODR_RESET_VALUE
 {
  PA_CR1 = 0xff;
  PA_ODR = 0;
  PA_DDR = 0;

  PB_CR1 = 1<<7|1<<6|1<<1|1;
  PB_ODR = 1<<7|1<<6|1<<1|1;
  PB_DDR = 1<<7|1<<5|1<<4|1<<1|1;

  PC_CR1 = 0xff;
  PC_ODR = 0xff;
  PC_DDR = 0xff;

  PD_CR1 = 0xff;
  PD_ODR = 0xff;

#ifdef debug
  PD_DDR = 0xff-2;
#else
  PD_DDR = 0xff;
#endif

  PE_CR1 = 0xff;
  PE_ODR = 0xff;
  PE_DDR = 0xff;

  PF_CR1 = 0xff;
  PF_ODR = 0xff;
  PF_DDR = 0xff;
 }
 void clk()
 {
  CLK->PCKENR1 = CLK_PCKENR1_TIM1|CLK_PCKENR1_TIM4;
  CLK->PCKENR2 = CLK_PCKENR2_ADC;
  CLK->CKDIVR  = bin(01)<<3; //hsi div=2
 }
 void t1()
 {
  u16 tmp;

  tmp = CPU_FRQ/CAR_FRQ/2-1;

  TIM1->PSCRL = 0;
  TIM1->ARRH  = tmp>>8;
  TIM1->ARRL  = (u8)tmp;
  TIM1->CR1   = TIM1_COUNTERMODE_CENTERALIGNED1;
  TIM1->CR2   = TIM1_CR2_CCPC;
  TIM1->RCR   = 1;
  TIM1->IER   = TIM1_IER_UIE;

  TIM1->CR2  |= TIM1_CR2_MMS;
  TIM1->CCR4H = tmp-1 >>8;
  TIM1->CCR4L = u8(tmp-1);

  tmp>>=1;

  TIM1->CCR1H = tmp>>8;
  TIM1->CCR1L = (u8)tmp;

  TIM1->CCMR1 = TIM1_OCMODE_PWM1|TIM1_CCMR_OCxPE;
  TIM1->CCMR4 = TIM1_OCMODE_PWM1;

  //        
  TIM1->CCER1 = 0x0f;

  TIM1->EGR  |= TIM1_EGR_COMG;

  TIM1->DTR   = bin(01111111);

  TIM1->CR1  |= TIM1_CR1_CEN;
 }
 void t4()
 {
   TIM4->ARR   = CPU_FRQ/128/1000 - 1;
   TIM4->PSCR  = 7;
   TIM4->IER   = 1;
   TIM4->CR1   = 1;
 }
 void adc()
 {
  ADC1->CR1  = ADC1_PRESSEL_FCPU_D10;
  ADC1->CR2  = ADC1_ALIGN_LEFT;//|ADC1_CR2_EXTTRIG;
  ADC1->CSR  = 3;
  ADC1->TDRL = 0x0f;
  ADC1->CR1 |= ADC1_CR1_ADON;
 }
 void iwdg()
 {
  IWDG_Enable();
  IWDG_WriteAccessCmd(IWDG_WriteAccess_Enable);
  IWDG_SetPrescaler(IWDG_Prescaler_256);
  IWDG_SetReload(0xff);
  IWDG_ReloadCounter();
 }
 void ee()
 {
#define sgn 10
  if(eep.init!=sgn)
  {
   FLASH_Unlock(FLASH_MEMTYPE_DATA);
   eep.init = sgn;

   FLASH_Lock(FLASH_MEMTYPE_DATA);
  }
 }
}cfg;

